Public Class MainForm
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents TestButton As System.Windows.Forms.Button
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.TestButton = New System.Windows.Forms.Button
        Me.SuspendLayout()
        '
        'TestButton
        '
        Me.TestButton.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.TestButton.Location = New System.Drawing.Point(272, 176)
        Me.TestButton.Name = "TestButton"
        Me.TestButton.Size = New System.Drawing.Size(72, 24)
        Me.TestButton.TabIndex = 0
        Me.TestButton.Text = "Test"
        '
        'MainForm
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(384, 245)
        Me.Controls.Add(Me.TestButton)
        Me.Name = "MainForm"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "MainForm"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Public Structure FTC_PAGE_WRITE_DATA
        Public NumPages As Integer
        Public NumBytesPerPage As Integer
    End Structure

    Private Declare Function I2C_GetNumDevices Lib "ftci2c" (ByRef NumDevices As Long) As Integer
    Private Declare Function I2C_GetDeviceNameLocID Lib "ftci2c" (ByVal DeviceNameIndex As Integer, ByVal DeviceName As String, ByVal BufferSize As Integer, ByRef lpLocationID As Long) As Integer
    Private Declare Function I2C_OpenEx Lib "ftci2c" (ByVal DeviceName As String, ByVal LocationID As Integer, ByRef ftHandle As Long) As Integer
    Private Declare Function I2C_Open Lib "ftci2c" (ByRef ftHandle As Long) As Integer
    Private Declare Function I2C_Close Lib "ftci2c" (ByVal ftHandle As Integer) As Integer
    Private Declare Function I2C_InitDevice Lib "ftci2c" (ByVal ftHandle As Integer, ByVal ClockDivisor As Integer) As Integer
    Private Declare Function I2C_GetClock Lib "ftci2c" (ByVal ClockDivisor As Integer, ByRef lpClockFrequencyHz As Long) As Integer
    Private Declare Function I2C_SetClock Lib "ftci2c" (ByVal ftHandle As Integer, ByVal ClockDivisor As Integer, ByRef lpClockFrequencyHz As Long) As Integer
    Private Declare Function I2C_SetLoopback Lib "ftci2c" (ByVal ftHandle As Integer, ByVal bLoopbackState As Boolean) As Integer
    Private Declare Function I2C_SetMode Lib "ftci2c" (ByVal ftHandle As Integer, ByVal CommsMode As Integer) As Integer
    Private Declare Function I2C_Write Lib "ftci2c" (ByVal ftHandle As Integer, ByVal WriteControlBuffer() As Byte, ByVal NumControlBytesToWrite As Integer, ByVal bControlAcknowledge As Boolean, ByVal NumControlAckTimeoutmSecs As Integer, ByVal bStopCondition As Boolean, ByVal DataWriteTypes As Integer, ByVal WriteDataBuffer() As Byte, ByVal NumDataBytesToWrite As Integer, ByVal bDataAcknowledge As Boolean, ByVal NumDataAckTimeoutmSecs As Integer, ByRef pPageWriteData As FTC_PAGE_WRITE_DATA) As Integer
    Private Declare Function I2C_Read Lib "ftci2c" (ByVal ftHandle As Integer, ByVal WriteControlBuffer() As Byte, ByVal NumControlBytesToWrite As Integer, ByVal bControlAcknowledge As Boolean, ByVal NumControlAckTimeoutmSecs As Integer, ByVal DataReadTypes As Integer, ByVal ReadDataBuffer() As Byte, ByVal NumDataBytesToRead As Integer) As Integer
    Private Declare Function I2C_GetDllVersion Lib "ftci2c" (ByVal DllVersion As String, ByVal BufferSize As Integer) As Integer
    Private Declare Function I2C_GetErrorCodeString Lib "ftci2c" (ByVal Language As String, ByVal StatusCode As Integer, ByVal ErrorMessage As String, ByVal BufferSize As Integer) As Integer

    Private Declare Function Sleep Lib "Kernel32" (ByVal Milliseconds As Integer) As Long

    Private Const FTC_SUCCESS = 0

    Private Const NO_WRITE_TYPE = 0
    Private Const BYTE_WRITE_TYPE = 1
    Private Const PAGE_WRITE_TYPE = 2

    Private Const BYTE_READ_TYPE = 1
    Private Const PAGE_READ_TYPE = 2

    Private Const STANDARD_MODE = 1
    Private Const FAST_MODE = 2

    Private Const WRITE_CONTROL_BUFFER_SIZE = 256
    Private Const WRITE_DATA_BUFFER_SIZE = 65536
    Private Const READ_DATA_BUFFER_SIZE = 65536

    Private Const MAX_NUM_DEVICE_NAME_CHARS = 100

    Private Const MAX_NUM_DLL_VERSION_CHARS = 10

    Private Const MAX_NUM_ERROR_MESSAGE_CHARS = 100

    Private Const App_Title = "FT2232C I2C Device Visual Basic .NET Test Application"

    Private Const MAX_I2C_M24C64_CHIP_SIZE_IN_BYTES = 512

    Private Const NUM_M24C64_PAGES = 1
    Private Const NUM_M24C64_BYTES_PER_PAGE = 32

    Private Const MAX_FREQ_M24C64_CLOCK_DIVISOR = 15   ' equivalent to 400KHz
    'Private Const MAX_FREQ_M24C64_CLOCK_DIVISOR = 60   ' equivalent to 100KHz

    Private ftHandle As Integer = 0

    Private Function ConvertDLLStringToVBString(ByRef DLLString As String) As String
        Dim VBString As String
        Dim iCharCntr As Integer = 0
        Dim CharArray() As Char

        While (DLLString.Chars(iCharCntr) <> vbNullChar)
            iCharCntr = iCharCntr + 1
        End While

        CharArray = New Char((iCharCntr - 1)) {}

        iCharCntr = 0
        While (DLLString.Chars(iCharCntr) <> vbNullChar)
            CharArray(iCharCntr) = DLLString.Chars(iCharCntr)
            iCharCntr = iCharCntr + 1
        End While

        VBString = New String(CharArray)

        Return VBString
    End Function
    Private Sub TestButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TestButton.Click
        Dim ftStatus As Integer = FTC_SUCCESS
        Dim NumDevices As Long = 0
        Dim DeviceName As String = New String(ChrW(0), MAX_NUM_DEVICE_NAME_CHARS)
        Dim DN As String
        Dim LocationID As Long = 0
        Dim ClockFrequencyHz As Long = 0
        Dim bLoopbackState As Boolean = False
        Dim DataWriteType As Integer
        Dim WriteDataByteAddress As Integer
        Dim WriteControlBuffer() As Byte = New Byte((WRITE_CONTROL_BUFFER_SIZE - 1)) {}
        Dim DataByte As Byte = 0
        Dim WriteDataBuffer() As Byte = New Byte((WRITE_DATA_BUFFER_SIZE - 1)) {}
        Dim NumDataBytesToWrite As Integer = 0
        Dim WriteDataBufferIndex As Integer = 0
        Dim PageWriteData As FTC_PAGE_WRITE_DATA
        Dim ReadDataBuffer() As Byte = New Byte((READ_DATA_BUFFER_SIZE - 1)) {}
        Dim ReadData() As Byte = New Byte((READ_DATA_BUFFER_SIZE - 1)) {}
        Dim ReadDataIndex As Integer = 0
        Dim ReadDataByteAddress As Integer = 0
        Dim DataReadType As Integer = 0
        Dim NumDataBytesToRead As Long = 0
        Dim MsgBoxKeyPressed As Integer = 0
        Dim DataByteWritten As Byte = 0
        Dim CharCntr As Integer = 0
        Dim iLoopCntr As Integer = 0
        Dim msg As String
        Dim style As MsgBoxStyle
        Dim response As MsgBoxResult

        Dim ErrorMessage As String = New String(ChrW(0), MAX_NUM_ERROR_MESSAGE_CHARS)

        'Dim DllVersion As String = New String(ChrW(0), MAX_NUM_DLL_VERSION_CHARS)

        'ftStatus = I2C_GetDllVersion(DllVersion, MAX_NUM_DLL_VERSION_CHARS)
        'MsgBox(DllVersion)

        ftStatus = I2C_GetNumDevices(NumDevices)

        If ((ftStatus = FTC_SUCCESS) And (NumDevices > 0)) Then
            If (NumDevices = 1) Then
                ftStatus = I2C_GetDeviceNameLocID(0, DeviceName, MAX_NUM_DEVICE_NAME_CHARS, LocationID)

                If (ftStatus = FTC_SUCCESS) Then
                    DN = New String(ConvertDLLStringToVBString(DeviceName))
                    ftStatus = I2C_OpenEx(DN, LocationID, ftHandle)
                End If

                'ftStatus = I2C_Open(ftHandle)
            Else
                If (NumDevices = 2) Then
                    ftStatus = I2C_GetDeviceNameLocID(1, DeviceName, MAX_NUM_DEVICE_NAME_CHARS, LocationID)

                    If (ftStatus = FTC_SUCCESS) Then
                        DN = New String(ConvertDLLStringToVBString(DeviceName))
                        ftStatus = I2C_OpenEx(DN, LocationID, ftHandle)
                    End If

                    'ftStatus = I2C_Open(ftHandle)
                End If
            End If

            If ((ftHandle <> 0) And (ftStatus = FTC_SUCCESS)) Then
                ftStatus = I2C_InitDevice(ftHandle, MAX_FREQ_M24C64_CLOCK_DIVISOR)

                If (ftStatus = FTC_SUCCESS) Then
                    ftStatus = I2C_GetClock(60, ClockFrequencyHz)
                End If

                'If (ftStatus = FTC_SUCCESS) Then
                'ftStatus = I2C_SetLoopback(ftHandle, False)
                'End If

                If (ftStatus = FTC_SUCCESS) Then
                    ftStatus = I2C_SetMode(ftHandle, FAST_MODE)
                End If

                If (ftStatus = FTC_SUCCESS) Then
                    WriteControlBuffer(0) = &HAE '1 0 1 0 A2 A1 A0 0 - device address 7

                    WriteDataBuffer(0) = &HFF  ' Erase address locations

                    WriteDataByteAddress = 0

                    Do
                        ' shift down by 8 bits
                        WriteControlBuffer(1) = ((WriteDataByteAddress >> 8) And &HFF)
                        WriteControlBuffer(2) = (WriteDataByteAddress And &HFF)

                        ftStatus = I2C_Write(ftHandle, WriteControlBuffer, 3, True, 20, True, BYTE_WRITE_TYPE, WriteDataBuffer, 1, True, 20, PageWriteData)

                        WriteDataByteAddress = WriteDataByteAddress + 1
                    Loop While ((WriteDataByteAddress < MAX_I2C_M24C64_CHIP_SIZE_IN_BYTES) And (ftStatus = FTC_SUCCESS))

                    Sleep(200)
                End If

                If (ftStatus = FTC_SUCCESS) Then
                    WriteControlBuffer(0) = &HAE '1 0 1 0 A2 A1 A0 0 - device address 7

                    WriteDataByteAddress = 0

                    DataWriteType = BYTE_WRITE_TYPE 'PAGE_WRITE_TYPE ';

                    DataByte = &H77

                    If (DataWriteType = BYTE_WRITE_TYPE) Then
                        WriteDataBuffer(0) = DataByte

                        NumDataBytesToWrite = 1
                    Else
                        WriteDataBuffer(0) = DataByte

                        PageWriteData.NumPages = NUM_M24C64_PAGES
                        PageWriteData.NumBytesPerPage = NUM_M24C64_BYTES_PER_PAGE

                        NumDataBytesToWrite = (NUM_M24C64_PAGES * NUM_M24C64_BYTES_PER_PAGE)

                        For WriteDataBufferIndex = 0 To (NumDataBytesToWrite - 1)
                            WriteDataBuffer(WriteDataBufferIndex) = DataByte
                        Next
                    End If

                    Do
                        ' performs an arithmetic right shift down by 8 bits
                        WriteControlBuffer(1) = ((WriteDataByteAddress >> 8) And &HFF)
                        WriteControlBuffer(2) = (WriteDataByteAddress And &HFF)

                        ftStatus = I2C_Write(ftHandle, WriteControlBuffer, 3, True, 20, True, DataWriteType, WriteDataBuffer, NumDataBytesToWrite, True, 20, PageWriteData)

                        If (DataWriteType = BYTE_WRITE_TYPE) Then
                            WriteDataByteAddress = WriteDataByteAddress + 1
                        Else
                            WriteDataByteAddress = WriteDataByteAddress + (NUM_M24C64_PAGES * NUM_M24C64_BYTES_PER_PAGE)
                        End If
                    Loop While ((WriteDataByteAddress < MAX_I2C_M24C64_CHIP_SIZE_IN_BYTES) And (ftStatus = FTC_SUCCESS))

                    If (ftStatus = FTC_SUCCESS) Then
                        Do
                            Sleep(200)

                            WriteControlBuffer(0) = &HAF '1 0 1 0 A2 A1 A0 1 - device address 7

                            For ReadDataIndex = 0 To (MAX_I2C_M24C64_CHIP_SIZE_IN_BYTES - 1)
                                ReadData(ReadDataIndex) = 0
                            Next

                            ReadDataByteAddress = 0

                            DataReadType = BYTE_READ_TYPE 'BLOCK_READ_TYPE '

                            If (DataReadType = BYTE_READ_TYPE) Then
                                NumDataBytesToRead = 1
                            Else
                                NumDataBytesToRead = MAX_I2C_M24C64_CHIP_SIZE_IN_BYTES
                            End If

                            Do
                                ' shift down by 8 bits
                                WriteControlBuffer(1) = ((ReadDataByteAddress >> 8) And &HFF)
                                WriteControlBuffer(2) = (ReadDataByteAddress And &HFF)

                                ftStatus = I2C_Read(ftHandle, WriteControlBuffer, 3, True, 20, DataReadType, ReadDataBuffer, NumDataBytesToRead)

                                If (ftStatus = FTC_SUCCESS) Then
                                    If (DataReadType = BYTE_READ_TYPE) Then
                                        ReadData(ReadDataByteAddress) = ReadDataBuffer(0)
                                    Else
                                        For ReadDataIndex = 0 To (MAX_I2C_M24C64_CHIP_SIZE_IN_BYTES - 1)
                                            ReadData(ReadDataIndex) = ReadDataBuffer(ReadDataIndex)
                                        Next
                                    End If

                                    If (DataReadType = BYTE_READ_TYPE) Then
                                        ReadDataByteAddress = ReadDataByteAddress + 1
                                    Else
                                        ReadDataByteAddress = ReadDataByteAddress + MAX_I2C_M24C64_CHIP_SIZE_IN_BYTES
                                    End If
                                End If
                            Loop While ((ReadDataByteAddress < MAX_I2C_M24C64_CHIP_SIZE_IN_BYTES) And (ftStatus = FTC_SUCCESS))

                            If (ftStatus = FTC_SUCCESS) Then
                                ReadDataIndex = 0

                                style = MsgBoxStyle.OKCancel
                                response = MsgBoxResult.OK

                                Do
                                    If (DataByte <> 0) Then
                                        DataByteWritten = DataByte
                                    Else
                                        DataByteWritten = (ReadDataIndex And &HFF)
                                    End If

                                    If (((ReadData(ReadDataIndex) <> DataByteWritten) And (DataByte <> 0)) Or ((ReadData(ReadDataIndex) <> DataByteWritten) And (DataByte = 0))) Then
                                        For CharCntr = 0 To (100 - 1)
                                            WriteDataBuffer(CharCntr) = 0
                                        Next

                                        msg = String.Format("I2C M24C64 Read/Write mismatch, Address = {0}, Write Value = {1}, Read Value = {2}", ReadDataIndex, DataByteWritten, ReadData(ReadDataIndex))

                                        response = MsgBox(msg, style, "I2C Read Error Message")
                                    End If

                                    ReadDataIndex = ReadDataIndex + 1
                                Loop While ((ReadDataIndex < MAX_I2C_M24C64_CHIP_SIZE_IN_BYTES) And (response = MsgBoxResult.OK))
                            End If

                            iLoopCntr = iLoopCntr + 1
                        Loop While ((iLoopCntr < 10) And (ftStatus = FTC_SUCCESS))

                        I2C_Close(ftHandle)
                        ftHandle = 0
                    End If
                End If
            End If
        End If

        If (ftStatus <> FTC_SUCCESS) Then
            ftStatus = I2C_GetErrorCodeString("EN", ftStatus, ErrorMessage, MAX_NUM_ERROR_MESSAGE_CHARS)

            MsgBox(ErrorMessage)
        End If
    End Sub

    Private Sub MainForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.Text = App_Title
    End Sub

    Private Sub MainForm_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        Dim ftStatus As Integer = FTC_SUCCESS

        If (ftHandle <> 0) Then
            ftStatus = I2C_Close(ftHandle)

            ftHandle = 0
        End If
    End Sub

End Class
